#!/usr/bin/X11/tixwish

proc printAdrView { } {
}

proc drawAddress { } {
    global adrWin username adro_owner lockAdr
    global adro_list adro_button addr_id adro_descr adro_notiz
    global pfnt12 pfnt bfnt12 bfnt fnt fnt12
    global addc_namet addc_name1 addc_name2 addc_fon addc_fon2 addc_fax addc_mail addc_www
    global addc_compS addc_comp  addc_adr1 addc_adr2 addc_adr3 addc_adr4 addc_adr5 addc_descrS addc_descr
    

    frame $adrWin.h -relief raised -bd 2
    frame $adrWin.l -relief raised -bd 2
    pack $adrWin.h $adrWin.l   -side top -fill x  

    label $adrWin.h.1 -relief raised -bd 1 -font $bfnt12 -text "Name" -anchor n -width 21
    label $adrWin.h.2 -relief raised -bd 1 -font $bfnt12 -text "Firma" -anchor n -width 38
    label $adrWin.h.3 -relief raised -bd 1 -font $bfnt12 -text "e-mail" -anchor n -width 27
    label $adrWin.h.4 -relief raised -bd 1 -font $bfnt12 -text "Telefon" -anchor n -width 19
    label $adrWin.h.5 -relief raised -bd 1 -font $bfnt12 -text "?" -anchor n -width 3 
    label $adrWin.h.6 -relief raised -bd 1 -font $bfnt12 -text "Kurzbeschreibung" -anchor n -width 24
    label $adrWin.h.7 -relief raised -bd 1 -font $bfnt12 -text " " -anchor n -width 2
    pack  $adrWin.h.1 $adrWin.h.2 $adrWin.h.3 $adrWin.h.4 $adrWin.h.5 $adrWin.h.6 $adrWin.h.7 -side left  -fill x


    set adro_list  $adrWin.l.l
    tixScrolledListBox $adro_list -scrollbar y -height 736 -width 970 -options {listbox.selectMode single} -browsecmd editAdress
    pack $adro_list
    $adro_list subwidget vsb configure -width 12
    $adro_list subwidget hsb configure -width 12
    $adro_list subwidget listbox configure -font $pfnt12
    $adro_list subwidget listbox configure  -selectmode single
    set lockAdr 0

    bind [$adro_list subwidget listbox]  <Button-3> {selectView %y}

#     puts ">>>>>>>>>>>>"
#     puts [bind $adro_list <Button-3>]
}


proc newAddress { } {
    editAddressDialog
    cleanAdress
}
proc editAdress { } {
    global adro_button  adr_list adrv_sel adro_list adro_descr addc_descr
    global addc_namet addc_name1 addc_name2
    update
    if { [winfo exists .adr] == 1} {return}

    editAddressDialog
    $adro_button configure -text "Adressse ndern"
    set selection  [$adro_list subwidget listbox curselection]
    set adr [lindex $adr_list $selection]
    set adrv_sel $selection
    setSelection2Current $adr
    fillNotiz
    $adro_descr  delete 0.0 end
    $adro_descr  insert end $addc_descr
    if { [string length [ string trim $addc_namet] ] >0 } {
	wm title .adr "Adresse von '$addc_namet $addc_name1 $addc_name2' ndern"
    } else {
	wm title .adr "Adresse von '$addc_name1 $addc_name2' ndern"
    }
}
proc setSelection2Current { adr } {
    global adro_list adr_list adro_descr addr_id addc_owner adro_button
    global addc_namet addc_name1 addc_name2 addc_fon addc_fon2 addc_fax addc_mail addc_www
    global addc_compS addc_comp  addc_adr1 addc_adr2 addc_adr3 addc_adr4 addc_adr5 addc_descrS addc_descr
    global username adro_notiz adrv_sel lockAdr


    set addr_id     [lindex $adr 0]
    set addc_namet  [lindex $adr 1]
    set addc_name1  [lindex $adr 2]
    set addc_name2  [lindex $adr 3]
    set addc_compS  [lindex $adr 4]
    set addc_comp   [lindex $adr 5]
    set addc_fon    [lindex $adr 6]
    set addc_fon2   [lindex $adr 7]
    set addc_fax    [lindex $adr 8]
    set addc_mail   [lindex $adr 9]
    set addc_www    [lindex $adr 10]

    set addc_adr1   [lindex $adr 11]
    set addc_adr2   [lindex $adr 12]
    set addc_adr3   [lindex $adr 13]
    set addc_adr4   [lindex $adr 14]
    set addc_adr5   [lindex $adr 15]
    set addc_descrS [lindex $adr 16]
    set addc_descr  [lindex $adr 17]
    set addc_owner  [lindex $adr 18]

#    $adro_descr  delete 0.0 end
#    $adro_descr  insert end $addc_descr

#    $adro_notiz subwidget text delete 0.0 end
#     set notiz [lindex [request getNotiz $username $addr_id] 0 ]
#     if { $notiz != "" } {
# 	$adro_notiz subwidget text insert end $notiz
#	puts [ $adro_notiz subwidget text bbox 0.0  ]
#	$adro_notiz adjustscrollregion
#     }

}
proc cleanAdress { } {
    global adro_list adr_list addr_id adro_descr adro_notiz adro_button
    global addc_namet addc_name1 addc_name2 addc_fon addc_fon2 addc_fax addc_mail addc_www
    global addc_compS addc_comp  addc_adr1 addc_adr2 addc_adr3 addc_adr4 addc_adr5 addc_descrS addc_descr
    
    set addc_namet  ""
    set addc_name1  ""
    set addc_name2  ""
    set addc_compS  ""
    set addc_comp   ""
    set addc_mail   ""
    set addc_fon    ""

    set addc_descrS ""
    set addc_descr  ""
    set addc_fax    ""
    set addc_fon2   ""
    set addc_www    ""
    set addc_adr1   ""
    set addc_adr2   ""
    set addc_adr3   ""
    set addc_adr4   ""
    set addc_adr5   ""
    $adro_descr  delete 0.0 end
    $adro_notiz  subwidget text delete 0.0 end
    set addr_id -1
    $adro_button configure -text "Adressse anlegen"
    .adr.a.r.1.b configure -state disabled 
}

proc editAddressDialog { } {
    global adrWin username adro_owner
    global adro_list adro_button addr_id adro_descr adro_notiz
    global pfnt12 pfnt bfnt12 bfnt fnt fnt12
    global addc_namet addc_name1 addc_name2 addc_fon addc_fon2 addc_fax addc_mail addc_www
    global addc_compS addc_comp  addc_adr1 addc_adr2 addc_adr3 addc_adr4 addc_adr5 addc_descrS addc_descr

    toplevel .adr
    frame .adr.a -relief raised -bd 1
    frame .adr.b 
    pack .adr.a .adr.b -side top -fill x
    
    frame .adr.a.l  -relief ridge -bd 2
#    frame .adr.a.m  -relief ridge -bd 2
    frame .adr.a.r -relief ridge -bd 2
    pack .adr.a.l  .adr.a.r -side left -fill x -padx 1 -pady 1
    

    for { set i 0 } {$i <18 } {incr i} {
	set win [format ".adr.a.l.%02d" $i ]
	frame $win
	pack $win -side top -fill x
    }

    label .adr.a.l.00.l -text "Titel" -width 15 -font $bfnt12
    label .adr.a.l.01.l -text "Vorname" -width  15 -font $bfnt12
    label .adr.a.l.02.l -text "Familienname" -width 15 -font $bfnt12
    label .adr.a.l.03.l -text "Firma (kurz)" -width 15 -font $bfnt12
    label .adr.a.l.04.l -text "Firma" -width 15 -font $bfnt12
    label .adr.a.l.05.l -text "Adresse" -width 15 -font $bfnt12
    label .adr.a.l.06.l -text " " -width 15 -font $bfnt12
    label .adr.a.l.07.l -text " " -width 15 -font $bfnt12
    label .adr.a.l.08.l -text " " -width 15 -font $bfnt12
    label .adr.a.l.09.l -text " " -width 15 -font $bfnt12
    label .adr.a.l.10.l -text "Telefon" -width 15 -font $bfnt12
    label .adr.a.l.11.l -text "Telefon (privat)" -width 15 -font $bfnt12
    label .adr.a.l.12.l -text "Fax" -width 15 -font $bfnt12
    label .adr.a.l.13.l -text "e-mail" -width 15 -font $bfnt12
    label .adr.a.l.14.l -text "WWW" -width 15 -font $bfnt12
    label .adr.a.l.15.l -text "Kurzbeschr." -width  15 -font $bfnt12 -anchor nw 
    label .adr.a.l.16.l -text "Beschreibung " -width  15 -font $bfnt12 -anchor nw 
 
    
    entry  .adr.a.l.00.e -width 12 -textvariable addc_namet -font $fnt
    entry  .adr.a.l.01.e -width 40 -textvariable addc_name1 -font $fnt
    entry  .adr.a.l.02.e -width 40 -textvariable addc_name2 -font $fnt
    entry  .adr.a.l.03.e -width 12 -textvariable addc_compS -font $fnt
    entry  .adr.a.l.04.e -width 40 -textvariable addc_comp  -font $fnt
    entry  .adr.a.l.05.e -width 40 -textvariable addc_adr1  -font $fnt
    entry  .adr.a.l.06.e -width 40 -textvariable addc_adr2  -font $fnt
    entry  .adr.a.l.07.e -width 40 -textvariable addc_adr3  -font $fnt
    entry  .adr.a.l.08.e -width 40 -textvariable addc_adr4  -font $fnt
    entry  .adr.a.l.09.e -width 40 -textvariable addc_adr5  -font $fnt
    entry  .adr.a.l.10.e -width 40 -textvariable addc_fon   -font $fnt
    entry  .adr.a.l.11.e -width 40 -textvariable addc_fon2  -font $fnt
    entry  .adr.a.l.12.e -width 40 -textvariable addc_fax   -font $fnt
    entry  .adr.a.l.13.e -width 40 -textvariable addc_mail  -font $fnt
    entry  .adr.a.l.14.e -width 40 -textvariable addc_www   -font $fnt
    entry  .adr.a.l.15.e -width 40 -textvariable addc_descrS  -font $fnt

    set adro_descr .adr.a.l.16.e
    text $adro_descr  -width 40 -height 4 -font $fnt

    set adro_owner .adr.a.l.17.e
    tixOptionMenu  $adro_owner -options {menubutton.width 40 label.width 15} -label "Eigentmer"
    $adro_owner subwidget label configure -font $bfnt12
    $adro_owner subwidget menubutton configure -font $fnt12

    $adro_owner add command Allgemein -label Allgemein

    for { set i 0 } {$i <17 } {incr i} {
	set win [format ".adr.a.l.%02d" $i ]
	pack $win.l $win.e -side left
    }
    pack $adro_owner  -side left

    frame .adr.a.r.1 
    frame .adr.a.r.2
    pack .adr.a.r.1 .adr.a.r.2 -side top -fill x -padx 3
    label .adr.a.r.1.l -text "Notiz " -width 12 -font $bfnt12 -anchor nw 
    button .adr.a.r.1.b -text " hinzufgen " -command {addNotizDialog}
    pack .adr.a.r.1.l -side left
    pack .adr.a.r.1.b -side right

    set adro_notiz .adr.a.r.2.e

    tixScrolledText $adro_notiz -scrollbar y -width 422 -height 460 -options {vsb.width 12}
    $adro_notiz subwidget text configure -font $fnt12
    $adro_notiz subwidget text configure -wrap none
    $adro_notiz subwidget vsb  configure -width 12
    $adro_notiz subwidget hsb  configure -width 12

    pack  $adro_notiz -side top

    
    set adro_button .adr.b.do
    button $adro_button -text "Adressse anlegen" -width 18 -command {addAdress} -font $bfnt
    pack $adro_button -side right
    button .adr.b.abb -text " Abbruch "  -command {closeWin .adr}
    pack .adr.b.abb -side left
    fillAdrList
    centerWin .adr 884 532
    update 
    grab .adr
    wm title .adr "neue Addresse anlegen"

#    puts [wm geometry .adr]
}

proc fillAdrList { } {
    global adro_owner username groupList addc_owner adr_list

    $adro_owner add command $username -label $username
    foreach group $groupList {
	$adro_owner add command $group -label $group
    }
	
    $adro_owner configure -variable addc_owner

#    fillAddress
}

proc addAdress { } {
    global adro_list adr_list adro_descr addr_id username adrv_sel
    global addc_namet addc_name1 addc_name2 addc_fon addc_fon2 addc_fax addc_mail addc_www addc_owner
    global addc_compS addc_comp  addc_adr1 addc_adr2 addc_adr3 addc_adr4 addc_adr5 addc_descrS addc_descr 
    

    set list [$adro_descr  dump -text 0.0 end ]
    set l [llength $list]
    set addc_descr ""
    for { set i 1} {$i < $l } {incr i 3 } {
	set addc_descr [format "%s%s" $addc_descr  [ lindex $list $i] ]
    }
    set addc_descr [string trim $addc_descr]

    set id [transfer changeAdr $addr_id $addc_namet $addc_name1  $addc_name2  $addc_compS  $addc_comp   \
	$addc_fon  $addc_fon2  $addc_fax  $addc_mail  $addc_www   \
	$addc_adr1  $addc_adr2  $addc_adr3  $addc_adr4  $addc_adr5 \
		$addc_descrS  $addc_descr  $addc_owner]
    
    
    set adr [request getAdr $username $id ]
    if { $addr_id<0 } {	
	lappend adr_list $adr
	set adrc_id $id
	cleanAdress
    } else {
	set adr_list [lreplace $adr_list  $adrv_sel $adrv_sel $adr ]
    }
    fillAddress
    closeWin .adr
}
proc delAddress { } { 
    global addr_id username adr_list

    request delAdr $username $addr_id

    set adr_list [request getAdrList $username ]
    fillAddress
}
proc addNotizDialog { } {
    global bfnt fnt addc_namet addc_name1 addc_name2

    toplevel .and
    frame .and.t -relief flat -bd 1
    frame .and.b 
    pack  .and.t .and.b -side top -fill x

    frame .and.t.1
    frame .and.t.2
    pack  .and.t.1 .and.t.2 -side top -fill x

    label .and.t.1.l -text "Notiz zu $addc_namet $addc_name1 $addc_name2" -font $bfnt
    pack .and.t.1.l -side left
    set new_comm ""

    tixScrolledText .and.t.2.e  -width 360 -height 280  -scrollbar y
    .and.t.2.e  subwidget text configure -wrap none
    pack .and.t.2.e  -side left
    .and.t.2.e subwidget vsb configure -width 12
    .and.t.2.e subwidget hsb configure -width 12
    button .and.b.can -text " Abbruch " -command {closeWin .and}
    button .and.b.add -text " Hinzufgen " -command {addNotiz }
    pack .and.b.can  -side left
    pack .and.b.add  -side right

    wm title .and "Notiz zu $addc_namet $addc_name1 $addc_name2 hinzufgen"
    centerWin .and 324 330
    grab .and
}
proc addNotiz { } {
    global  username addr_id adro_notiz
    
    set list [ .and.t.2.e subwidget text dump -text 0.0 end]
    set notiz ""
    set l [llength $list]
    for { set i 1} {$i < $l } {incr i 3 } {
	set notiz [format "%s%s" $notiz [ lindex $list $i] ]
    }
    set notiz [string trim $notiz]
    transfer addNotiz $username $addr_id  $notiz
    

    fillNotiz
#     $adro_notiz subwidget text delete 0.0 end
#     set notiz [lindex [request getNotiz $username $addr_id] 0]
#     if { $notiz != "" } {
# 	$adro_notiz subwidget text insert end $notiz
#     }
    closeWin .and
}


proc fillAddress { } {
    global adro_list adr_list

    
    $adro_list subwidget listbox delete 0 end
    foreach adr $adr_list {
	set name [format "%s %s %s" [lindex $adr 1] [lindex $adr 2] [lindex $adr 3]]
	if { [string length $name] >20 } {
	    set name [format "%s %s. %s" [lindex $adr 1] [string range [lindex $adr 2] 0 0] [lindex $adr 3]]
	}
	set name [string trim $name]
	set str [format "%-20s  %-6s,%-30s  %-25s  %18s  %1s %-24s" \
		     [strTrunc $name 20 ] [strTrunc [lindex $adr 4] 6] [strTrunc [lindex $adr 5] 30 ] \
		     [strTrunc [lindex $adr 9] 25] [strTrunc [lindex $adr 6] 18]  \
 		     [termin4Address [lindex $adr 19]] [strTrunc [lindex $adr 16] 24] ]
	$adro_list subwidget listbox insert end $str
    }
}
proc fillNotiz { } {
    global username addr_id adro_notiz

    $adro_notiz subwidget text delete 0.0 end
    set notiz [lindex [request getNotiz $username $addr_id] 0 ]
    if { $notiz != "" } {
	$adro_notiz subwidget text insert end $notiz
    }
    $adro_notiz subwidget text see end
}

proc selectView { y } {
    global adro_list adr_list adrv_sel  adro_descr addc_descr

#FIXME lange Addresslisten
    set yk $y
    set selection  [$adro_list subwidget listbox nearest $yk]
    $adro_list subwidget listbox selection clear 0 end
    $adro_list subwidget listbox selection set $selection
    set adr [lindex $adr_list $selection]
    set adrv_sel $selection
    setSelection2Current $adr
    viewAddressDialog 
    $adro_descr  delete 0.0 end
    $adro_descr  insert end $addc_descr
    fillNotiz
}


proc viewAddressDialog { } {
    global adrWin username adro_owner
    global adro_list adro_button addr_id adro_descr adro_notiz
    global pfnt12 pfnt bfnt12 bfnt fnt fnt12
    global addc_namet addc_name1 addc_name2 addc_fon addc_fon2 addc_fax addc_mail addc_www
    global addc_compS addc_comp  addc_adr1 addc_adr2 addc_adr3 addc_adr4 addc_adr5 addc_descrS addc_descr
    global addc_owner addc_curName

    toplevel .adv
    frame .adv.a -relief raised -bd 1
    frame .adv.b 
    pack .adv.a .adv.b -side top -fill x
    
    frame .adv.a.l  -relief ridge -bd 2
#    frame .adv.a.m  -relief ridge -bd 2
    frame .adv.a.r -relief ridge -bd 2
    pack .adv.a.l  .adv.a.r -side left -fill x -padx 1 -pady 1
    

    for { set i 0 } {$i <18 } {incr i} {
	set win [format ".adv.a.l.%02d" $i ]
	frame $win
	pack $win -side top -fill x
    }
    
    if { [string length [ string trim $addc_namet] ] >0 } {
	set addc_curName "$addc_namet $addc_name1 $addc_name2"
    } else {
	set addc_curName "$addc_name1 $addc_name2"
    }

    
    label .adv.a.l.00.l -text "Name " -width 15 -font $bfnt
    label .adv.a.l.01.l -text "Firma " -width 15 -font $bfnt
    label .adv.a.l.02.l -text "   " -width 15 -font $bfnt
    label .adv.a.l.03.l -text "Adresse" -width 15 -font $bfnt
    label .adv.a.l.04.l -text " " -width 15 -font $bfnt
    label .adv.a.l.05.l -text " " -width 15 -font $bfnt
    label .adv.a.l.06.l -text " " -width 15 -font $bfnt
    label .adv.a.l.07.l -text " " -width 15 -font $bfnt
    label .adv.a.l.08.l -text "Telefon" -width 15 -font $bfnt
    label .adv.a.l.09.l -text "Telefon (privat)" -width 15 -font $bfnt
    label .adv.a.l.10.l -text "Fax" -width 15 -font $bfnt
    label .adv.a.l.11.l -text "e-mail" -width 15 -font $bfnt
    label .adv.a.l.12.l -text "WWW" -width 15 -font $bfnt
    label .adv.a.l.13.l -text "Kurzbeschr." -width  15 -font $bfnt -anchor nw 
    label .adv.a.l.14.l -text "Beschreibung " -width  15 -font $bfnt -anchor nw 
    label .adv.a.l.15.l -text "Eigentmer " -width  15 -font $bfnt -anchor nw 
 
    

    label  .adv.a.l.00.e -width 12 -text $addc_curName -font $fnt
    label  .adv.a.l.01.e -width 12 -text $addc_compS -font $fnt
    label  .adv.a.l.02.e -width 40 -text $addc_comp  -font $fnt
    label  .adv.a.l.03.e -width 40 -text $addc_adr1  -font $fnt
    label  .adv.a.l.04.e -width 40 -text $addc_adr2  -font $fnt
    label  .adv.a.l.05.e -width 40 -text $addc_adr3  -font $fnt
    label  .adv.a.l.06.e -width 40 -text $addc_adr4  -font $fnt
    label  .adv.a.l.07.e -width 40 -text $addc_adr5  -font $fnt
    label  .adv.a.l.08.e -width 40 -text $addc_fon   -font $fnt
    label  .adv.a.l.09.e -width 40 -text $addc_fon2  -font $fnt
    label  .adv.a.l.10.e -width 40 -text $addc_fax   -font $fnt
    label  .adv.a.l.11.e -width 40 -text $addc_mail  -font $fnt
    label  .adv.a.l.12.e -width 40 -text $addc_www   -font $fnt
    label  .adv.a.l.13.e -width 40 -text $addc_descrS  -font $fnt

    set adro_descr .adv.a.l.14.e
    text $adro_descr  -width 40 -height 4 -font $fnt -state normal
    $adro_descr insert end $addc_descr
    $adro_descr configure -state disabled

    label  .adv.a.l.15.e -width 40 -text $addc_owner  -font $fnt


    for { set i 0 } {$i <16 } {incr i} {
	set win [format ".adv.a.l.%02d" $i ]
	pack $win.l $win.e -side left -pady 1
    }
#     pack $adro_owner  -side left

    frame .adv.a.r.1 
    frame .adv.a.r.2
    pack .adv.a.r.1 .adv.a.r.2 -side top -fill x -padx 3
    label .adv.a.r.1.l -text "Notiz " -width 12 -font $bfnt -anchor nw 
    button .adv.a.r.1.b -text " hinzufgen " -command {addNotizDialog}
    pack .adv.a.r.1.l -side left
    pack .adv.a.r.1.b -side right

    set adro_notiz .adv.a.r.2.e

    tixScrolledText $adro_notiz -scrollbar y -width 422 -height 348 -options {vsb.width 12}
    $adro_notiz subwidget text configure -font $fnt12
    $adro_notiz subwidget text configure -wrap none
    $adro_notiz subwidget vsb  configure -width 12
    $adro_notiz subwidget hsb  configure -width 12

    pack  $adro_notiz -side top

    
    set adro_button .adv.b.do
    button .adv.b.do -text "Schliessen" -width 18 -command {closeWin .adv} -font $fnt
    pack .adv.b.do -side right
    button .adv.b.mod -text "ndern" -width 18  -font $fnt -command {
	editAdress
	destroy .adv 
    }
    pack .adv.b.mod -side right -pady 3
    button .adv.b.del -text "Lschen" -width 18 -command {checkDelAdrDialog} -font $fnt
    pack .adv.b.del -side right -pady 6

    centerWin .adv 896 430
    update 
    grab .adv
    wm title .adv "Adresse von '$addc_curName'"

#    puts [wm geometry .adv]
}
proc checkDelAdrDialog { } {
    global addc_curName
    global bfnt  eddLock


    toplevel .cda
    frame .cda.t -relief raised -bd 1
    frame .cda.b 
    pack .cda.t  -side top -fill x
    pack .cda.b -side top -fill x -pady 3

    label .cda.t.1 -text "Wollen sie die Addresse von " -font $bfnt -justify center -anchor n
    label .cda.t.2 -text "\"$addc_curName\""  -font $bfnt -justify center -anchor n
    label .cda.t.3 -text "wirklich lschen?"  -font $bfnt -justify center -anchor n
    pack .cda.t.1 .cda.t.2 .cda.t.3 -side top -fill x
    
    button .cda.b.abb -text "   NEIN   "   -font $bfnt -command {
	closeWin .cda
	closeWin .vpd
    }
    pack .cda.b.abb -side right
    button .cda.b.del -text " ja "  -font $bfnt -command {
	closeWin  .adv
	closeWin .cda
	delAddress
    }
    pack .cda.b.del -side left
    centerWin .cda 208 96
    update
#    puts [wm geometry .cda]
    grab .cda

}

proc termin4Address {str} {
    if { $str == 1} {
	return "+"
    }
    return " "
}

