#!/usr/bin/X11/tixwish

proc viewDate { did date tim } { 
    global fnt bfnt fnt12 bfnt12  bfnt11 fnt11 bfnt10 fnt10
    global partStatus partStatusStr username eddv_repTypStr
    global userList fullUserNameList
    global curr_did eddLock curr_perms
    global curDateTitel fullUsername curDate
    global currDate currTime
    global currRefDate currRefTime
    global vdStatusPopWin vdCan
    global vd_igno vd_noRem
    global vdo_igno vdo_noRem
    global vd_needReDraw
    global vd_deleteDateIcon vd_suspendDateIcon vd_shiftDateIcon 
    global vd_modifyDateIcon vd_reminderOnIcon vd_reminderOffIcon
    global ignoreIcon_in ignoreIcon_out

    set currDate $date
    set currTime $tim
    set vd_needReDraw 0

    toplevel .vd

    frame .vd.t -relief raised -bd 1
    frame .vd.b
    pack .vd.t .vd.b -side top -fill x -expand 1 -pady 2 

    frame .vd.t.b -relief raised -bd 1
    frame .vd.t.2 -relief ridge -bd 2
    frame .vd.t.4 -relief ridge -bd 2

    pack .vd.t.b   .vd.t.2   .vd.t.4 -side top -fill x -expand 1 -pady 2 -padx 4 -ipadx 2 -pady 2



#    puts stdout "request for $did"

    set ret [ request getBriefDate $username $did $date]
    set curr_did $did

    set perm  [val2perm [lindex $ret 0]]
    perm2rw  $perm 
    set titel [lindex $ret 1]
    set curDateTitel $titel
    set dat   [lindex $ret 2]
    set tim   [lindex $ret 3]
    set y0    [expr $dat /10000 ]
    set mon0  [expr [expr $dat /100] % 100 ]
    set day0  [expr $dat %100 ]
    set h0    [expr $tim /100 ]
    set m0    [expr $tim %100 ]
    set dat   [lindex $ret 4]
    set tim   [lindex $ret 5]
    set y1    [expr $dat /10000 ]
    set mon1  [expr [expr $dat /100] % 100 ]
    set day1  [expr $dat %100 ]
    set h1    [expr $tim /100 ]
    set m1    [expr $tim %100 ]
    set repTyp [lindex $ret 12]
    set noTime [lindex $ret 13]
    set currRefDate [lindex $ret 14]
    set currRefTime [lindex $ret 15]
    set vd_igno  [lindex $ret 16]
    set vd_noRem [lindex $ret 17]

    set room  [lindex $ret 6]
    set details [lindex $ret 7]
    set priv ""
    if { [lindex $ret 9] == 1} { set priv "(gruppenintern)   "}
    if { [lindex $ret 8] == 1} { set priv "(privat)   "}
#    puts [format "%s %s '%s'"  [lindex $ret 7]  [lindex $ret 8] $priv]

    set part [lindex $ret 10]
    set group [lindex $ret 11]

#    puts "$repTyp <- $ret "






#Der Toolbar
    set ballon .vd.bal
    tixBalloon $ballon  -initwait 2000 -state balloon

    button .vd.t.b.del -image [image create pixmap -data $vd_deleteDateIcon] -command {
	    set del_did $curr_did
	    checkDelDateDialog
    }
    if { $repTyp !=0 } {
	button .vd.t.b.susp -image [image create pixmap -data $vd_suspendDateIcon] -command {
	    closeWin .vd
	    checkSuspDateDialog $curr_did
	}
	button .vd.t.b.shift -image [image create pixmap -data $vd_shiftDateIcon]  -command {
	    closeWin .vd
	    shiftDate $curr_did $currDate $currTime $currRefDate $currRefTime
	} 
    }
    button .vd.t.b.edit -image [image create pixmap -data $vd_modifyDateIcon] -command {
	closeWin .vd
	editDate $curr_did }
    pack .vd.t.b.del -side left 
    if {  $repTyp !=0 } {
	pack .vd.t.b.susp -side left -padx 16
	pack .vd.t.b.shift .vd.t.b.edit -side left -padx 2
    } else  {
	pack  .vd.t.b.edit -side left -padx 20
    }
    
    puts ">>> $vd_igno  $vd_noRem <<<"

    button .vd.t.b.ign -image [image create pixmap -data $ignoreIcon_in] -command {
	if {$vd_igno == 1} {
	    set vd_igno 0
	    .vd.t.b.ign configure -image [image create pixmap -data $ignoreIcon_in]
	} else {
	    set vd_igno 1
	    .vd.t.b.ign configure -image [image create pixmap -data $ignoreIcon_out]
	}
	transfer ignoreDate $curr_did $username $vd_igno
	set vd_needReDraw 1
    }
    $ballon bind .vd.t.b.ign -balloonmsg "Zeigt an ob dieser Termin ignoriert werden soll.\nMit einem Druck auf diesen Knopft kann der zwischen\n ignorieren und nicht ignorieren gewechselt werden."
    button .vd.t.b.rem  -image [image create pixmap -data $vd_reminderOnIcon] -command {
	if {$vd_noRem == 1} {
	    set vd_noRem 0
	    .vd.t.b.rem configure  -image [image create pixmap -data $vd_reminderOnIcon]
	} else {
	    set vd_noRem 1
	    .vd.t.b.rem configure -image [image create pixmap -data $vd_reminderOffIcon]
	}
	transfer doNotremind $curr_did $username $vd_noRem
    }
    $ballon bind .vd.t.b.rem -balloonmsg "Zeigt an ob Erinnerungen und Einladungen zu diesem Termin\n unterdrckt werden oder nicht. Durch eine Druck auf diesen Knopf kann die \nUnterdrckung ein- und aus geschaltet werden."
    pack .vd.t.b.ign -side right
    pack .vd.t.b.rem -side right -padx 2

    if { $vd_igno  == 1 } {.vd.t.b.ign configure  -image [image create pixmap -data $ignoreIcon_out]}
    if { $vd_noRem == 1 } {.vd.t.b.rem configure  -image [image create pixmap -data $vd_reminderOffIcon]}

    if { $curr_perms(dd) == 0} { 
	.vd.t.b.del configure -state disabled 
	if { $repTyp !=0 } { .vd.t.b.susp configure -state disabled}
    } else {
	$ballon bind .vd.t.b.del -balloonmsg "Dieser Knopf lscht diesen Termin"
	if { $repTyp !=0 } {$ballon bind .vd.t.b.susp -balloonmsg "Mit diesem Knopf kann ein Wiederholungstermin\n an einem bestimmten Tag ausgesetzt werden." }
    }
    if { $curr_perms(w) == 0} { 
	.vd.t.b.edit configure -state disabled 
	if { $repTyp !=0 } {	.vd.t.b.shift configure -state disabled}
    } else {
	$ballon bind .vd.t.b.edit -balloonmsg "Hiermit wechselt man in den nderungsdialog zu diesem Termin"
	if { $repTyp !=0 } {$ballon bind .vd.t.b.shift -balloonmsg "Mit diesem Konopf kann man eine bestimmte Instanz\n eines Wiederholungstermins verschieben, bzw. verlegen"}
    }

    if { $curr_perms(r)==1 } {
 	label .vd.t.b.t -justify center  -text $titel -font $bfnt -anchor n  -width 108 -relief sunken -bd 1
    } else {
 	label .vd.t.b.t -justify center  -text "" -font $bfnt -anchor n  -width 108 -relief sunken -bd 1
    }
    pack .vd.t.b.t -side right


    frame .vd.t.2.1
    frame .vd.t.2.2
    pack  .vd.t.2.1  .vd.t.2.2 -side top -fill x -pady 2

    label .vd.t.2.1.l -text "Zeit  : " -font $bfnt
    if { $curr_perms(rz) == 1} {
	if { $repTyp == 0} {
	    if { $noTime == 0 } {
		label .vd.t.2.1.t -font $fnt \
		    -text [format "von %2d.%2d.%4d, %2d:%02d bis %2d.%2d.%4d, %2d:%02d" \
			       $day0 $mon0 $y0 $h0 $m0 $day1 $mon1 $y1 $h1 $m1 ]
	    } else { 
		label .vd.t.2.1.t -font $fnt \
		    -text [format "von %2d.%2d.%4d bis %2d.%2d.%4d" \
			       $day0 $mon0 $y0 $day1 $mon1 $y1 ]
	    }
	} else {
	    if { $noTime == 0 } {
		label .vd.t.2.1.t -font $fnt \
		    -text [format "von %2d.%2d.%4d, %2d:%02d bis %2d.%2d.%4d, %2d:%02d  (%s)" \
			       $day0 $mon0 $y0 $h0 $m0 $day1 $mon1 $y1 $h1 $m1 [lindex $eddv_repTypStr $repTyp] ]
	    } else { 
		label .vd.t.2.1.t -font $fnt \
		    -text [format "von %2d.%2d.%4d bis %2d.%2d.%4d  (%s)" \
			       $day0 $mon0 $y0 $day1 $mon1 $y1 [lindex $eddv_repTypStr $repTyp] ]
	    }
	}
    } else { 
	label .vd.t.2.1.t -text "" -font $fnt
    }
    label .vd.t.2.1.g -font $fnt -text $priv
    pack .vd.t.2.1.l  .vd.t.2.1.t -side left 
    pack .vd.t.2.1.g -side right

    label .vd.t.2.2.l -text "Ort   : " -font $bfnt
    if { $curr_perms(rz) == 1} {
	label .vd.t.2.2.t -font $fnt -text $room
    } else {
	label .vd.t.2.2.t -text "" -font $fnt
    }
    label .vd.t.2.2.lg -text "Gruppe : " -font $bfnt 
    if { $curr_perms(rt) == 1} {
	label .vd.t.2.2.tg -font $fnt -text $group -width 16 -justify right -anchor e
    } else {
	label .vd.t.2.2.tg -text "" -font $fnt -width 16 -justify right -anchor e
    }
    label .vd.t.2.2.spc -text "   " 
    pack .vd.t.2.2.l  .vd.t.2.2.t  -side left 
    pack  .vd.t.2.2.spc .vd.t.2.2.tg  .vd.t.2.2.lg -side right 


    frame .vd.t.4.l -relief raised -bd 1
    frame .vd.t.4.r -relief raised -bd 1
    pack .vd.t.4.l .vd.t.4.r -side left -fill x -padx 2 -pady 2
    frame .vd.t.4.l.l 
    frame .vd.t.4.l.t
    pack .vd.t.4.l.l .vd.t.4.l.t -side top -fill x
    label .vd.t.4.l.l.l -text "Details:" -font $bfnt
    tixScrolledText .vd.t.4.l.t.t  -width 256 -height 128
    .vd.t.4.l.t.t subwidget text configure -font $fnt12
    .vd.t.4.l.t.t subwidget text configure -wrap word
    .vd.t.4.l.t.t subwidget vsb configure -width 12
    .vd.t.4.l.t.t subwidget hsb configure -width 12
    pack  .vd.t.4.l.l.l .vd.t.4.l.t.t  -side left
    .vd.t.4.l.t.t subwidget text delete 0.0 end
    if { $curr_perms(r) == 1} {
	.vd.t.4.l.t.t subwidget text insert end $details
    }
    .vd.t.4.l.t.t subwidget text configure -state disabled
    

    

    frame .vd.t.4.r.l 
    frame .vd.t.4.r.t
    pack .vd.t.4.r.l .vd.t.4.r.t -side top -fill x

    set scan .vd.t.4.r.t.t
    label .vd.t.4.r.l.l -text "Teilnehmer:" -font $bfnt -anchor nw 
    tixCObjView  $scan -width 272 -height 128 -scrollbar "auto -x"
    $scan subwidget vsb configure -width 12
    $scan subwidget hsb configure -width 12
    pack .vd.t.4.r.l.l  $scan -side left

    set vdCan [$scan subwidget canvas]
    
    set y 3
    set dy 15
    set meListed 0

    set vdStatusPopWin .vd.pu
    tixPopupMenu $vdStatusPopWin -title "Status" -spring false
    set anz [ llength $partStatus]
    for { set i 1 } { $i <$anz } {incr i} {
	$vdStatusPopWin subwidget menu add command -label [lindex $partStatusStr $i] -command {vdSetPartStatus %W}
	$vdStatusPopWin subwidget menu entryconfigure  [lindex $partStatusStr $i] -command "vdSetPartStatus $i"
    }

    foreach val $part {
	set type  [ lindex $val 0]
	set name  [ lindex $val 1]
	set stat  [ lindex $val 2]
	set ugType [ lindex $val 3]
	
	#	puts "VD: PERM=$curr_perms(rt) // '$name' != '$fullUsername' ? "
	if {$curr_perms(rt)== 0 && $name != $fullUsername } {
	    continue 
	}
	if { $name == $fullUsername } { set meListed 1}
	
	if {$ugType == "g"} { 
	    set uname $name
	    set name "Gruppe $name"
	}
	if {$ugType == "u"} { 
	    set uname [ lindex $userList [ lsearch $fullUserNameList $name] ]
	}
	
	#	set y2 [expr $y +2]
	set y2 $y
	switch $type {
	    I {	$vdCan create text 8 $y2 -text " I " -anchor n -justify center -fill red -font $bfnt12}
	    E {	$vdCan create text 9 $y2 -text " E " -anchor n -justify center -fill DarkOrange -font $bfnt12}
	    T {	$vdCan create text 8 $y2 -text " T " -anchor n -justify center -fill green4 -font $bfnt12}
	    A {	$vdCan create text 8 $y2 -text " A " -anchor n -justify center -fill blue2 -font $bfnt12} 
	    i {	$vdCan create text 8 $y2 -text " i " -anchor n -justify center -fill black -font $bfnt12} 
	    * {	$vdCan create text 8 $y2 -text " T " -anchor n -justify center -fill green3 -font $bfnt12} 
	}
	$vdCan create text 16 $y -text $name -anchor nw -font $fnt12
	#	set id [lsearch $partStatus $stat ]
	#	if { $id <=0} { set id 0 }
	set tag "stat-$ugType-$uname"
	$vdCan create text 180 $y -text [ lindex $partStatusStr $stat] -anchor nw -font $fnt12 -tag $tag
	if { $meListed ==1 || $curr_perms(wt) == 1} {
	    $vdCan bind $tag <Button> {statusPopup  $vdCan %x %y }
	    puts "binding on tag /$tag/"
# 	    puts "$name: $tag"
# 	    puts [bind $vdCan <Button>] 
# 	    puts [$vdCan bind $tag]
# 	    puts ""
	}
	incr y $dy
    }
	
#     button .vd.b.del -text " Lschen " -command {
# 	    set del_did $curr_did
# 	    checkDelDateDialog
#     }

#     button .vd.b.del -text " Lschen " -command {
# 	closeWin .vd
# 	set del_did $curr_did
# 	doDeleteDate
# 	set eddLock 0
#     }

#     if { $curr_perms(dd) == 0} { 
# 	.vd.b.del configure -state disabled 
# 	.vd.b.susp configure -state disabled
#     }


#     button .vd.b.shift -text "Verschieben/Verlegen" -command {
# 	closeWin .vd
# 	shiftDate $curr_did $currDate $currTime $currRefDate $currRefTime
#     } 
#     button .vd.b.susp -text "Aussetzen" -command {
# 	closeWin .vd
# 	checkSuspDateDialog $curr_did
#     }
    

#     button .vd.b.edit -text " ndern " -command {
# 	closeWin .vd
# 	editDate $curr_did }
#     if { $curr_perms(w) == 0} { 
# 	if { $meListed == 0 } {
# 	    .vd.b.edit configure -state disabled 
# 	    .vd.b.shift configure -state disabled
# 	}
#     }
    
    button .vd.b.close -text " Schlieen " -command {
	closeWin .vd
	set eddLock 0
	if { $vd_needReDraw == 1} {drawCal}
    }
    puts "pack close"
    pack  .vd.b.close -side right
    puts "done"
#     pack  .vd.b.close .vd.b.edit .vd.b.shift -side right
#     pack   .vd.b.del  -side left 
#     pack .vd.b.susp  -side left -padx 12
 
    if { $curr_perms(r)==1 } {
	wm title .vd [format "Termin: %s" $titel ]
    }
    centerWin .vd 558 298 
    grab .vd 
}
proc statusPopup {cwin x y} {
    global vdStatusPopWin vdCan vd_popupTag
    set list [ $cwin gettags [ $cwin find closest $x $y]]
    set id [lsearch  -glob $list stat-* ]
    set vd_popupTag [ lindex $list $id]
    puts "$x/$y -> '$list' -> '$id' ->'$vd_popupTag'"
    $vdStatusPopWin post $cwin  $x $y
}
    
proc vdSetPartStatus {status} {
    global vdCan currUser vd_popupTag partStatusStr currRefDate currRefTime curr_did

    set list  [split $vd_popupTag -]
    set uname [lindex  $list 2]
    set ug  [lindex  $list 1]
    transfer changeStatus $curr_did $currRefDate $currRefTime $uname $status $ug
    $vdCan itemconfigure $vd_popupTag -text [ lindex $partStatusStr $status]
}

proc checkDelDateDialog { } {
    global curDateTitel
    global bfnt  eddLock


    toplevel .cdd
    frame .cdd.t -relief raised -bd 1
    frame .cdd.b 
    pack .cdd.t  -side top -fill x
    pack .cdd.b -side top -fill x -pady 3

    label .cdd.t.1 -text "Wollen sie den Termin" -font $bfnt -justify center -anchor n
    label .cdd.t.2 -text "\"$curDateTitel\""  -font $bfnt -justify center -anchor n
    label .cdd.t.3 -text "wirklich lschen?"  -font $bfnt -justify center -anchor n
    pack .cdd.t.1 .cdd.t.2 .cdd.t.3 -side top -fill x
    
    button .cdd.b.abb -text "   NEIN   "   -font $bfnt -command {
	closeWin .cdd
    }
    pack .cdd.b.abb -side right
    button .cdd.b.del -text " ja "  -font $bfnt -command {
	closeWin  .cdd
	closeWin .vd
	doDeleteDate
	set eddLock 0
    }
    pack .cdd.b.del -side left
    centerWin .cdd 200 100
    update
    grab .cdd

}
proc checkSuspDateDialog { did } {
    global curDateTitel
    global bfnt  eddLock
    global del_tag del_did
    global dateByTag timeByTag

    set del_did $did
    toplevel .cdd
    frame .cdd.t -relief raised -bd 1
    frame .cdd.b 
    pack .cdd.t  -side top -fill x
    pack .cdd.b -side top -fill x -pady 3

    label .cdd.t.1 -text "Wollen sie den Termin" -font $bfnt -justify center -anchor n
    label .cdd.t.2 -text "\"$curDateTitel\""  -font $bfnt -justify center -anchor n
    label .cdd.t.3 -text [format "am %s um %s" [date2Str $dateByTag($del_tag)] [time2Str $timeByTag($del_tag)]  ] \
	-font $bfnt -justify center -anchor n
    label .cdd.t.4 -text "wirklich aussetzen?"  -font $bfnt -justify center -anchor n
    pack .cdd.t.1 .cdd.t.2 .cdd.t.3 .cdd.t.4 -side top -fill x
    
    button .cdd.b.abb -text "   NEIN   "   -font $bfnt -command {
	closeWin .cdd
    }
    pack .cdd.b.abb -side right
    button .cdd.b.del -text " ja "  -font $bfnt -command {
	closeWin  .cdd
	closeWin .vd
	doSuspendDate
	set eddLock 0
    }
    pack .cdd.b.del -side left
    centerWin .cdd 200 120
    update
#    puts [wm geometry .cdd]
    grab .cdd

}



proc shiftDate { did date tim rdate rtim} {
    global shiftTitel
    global shiftStartDay shiftStartMon shiftStartYear shiftStartHour shiftStartMin
    global shiftStopDay shiftStopMon shiftStopYear shiftStopHour shiftStopMin
    global shiftRoom shiftAddDet shiftRefDate shiftRefTime shiftDid
    global roomList
    global sdo_startDy sdo_startDm sdo_startDd sdo_startTh sdo_startTm 
    global sdo_stopDy sdo_stopDm sdo_stopDd sdo_stopTh sdo_stopTm 
    global sdo_room
    global fnt bfnt fnt12 bfnt12 pfnt
    global dateByTag timeByTag

    
    set shiftDid $did
    set shiftRefDate $rdate
    set shiftRefTime $rtim

    set ret [request shiftDateInfo  $did $rdate $rtim ]
    set shiftTitel     [lindex $ret 0]
    set dlist           [date2list [lindex $ret 1]]
    set shiftStartDay  [lindex $dlist 0]
    set shiftStartMon  [lindex $dlist 1]
    set shiftStartYear [lindex $dlist 2]
    set shiftStartHour [expr [lindex $ret 2] /100 ]
    set shiftStartMin  [expr [lindex $ret 2] %100 ]
    set dlist          [date2list [lindex $ret 3]]
    set shiftStopDay   [lindex $dlist 0]
    set shiftStopMon   [lindex $dlist 1]
    set shiftStopYear  [lindex $dlist 2]
    set shiftStopHour  [expr [lindex $ret 4] /100 ]
    set shiftStopMin   [expr [lindex $ret 4] %100 ]
    set shiftRoom      [lindex $ret 5]
    set shiftAddDet    [lindex $ret 6]

    toplevel .sd


    frame .sd.t -relief raised -bd 1
    frame .sd.b
    pack .sd.t .sd.b -side top -fill x

    frame .sd.t.d -relief ridge -bd 2
    frame .sd.t.r -relief ridge -bd 2
    frame .sd.t.c -relief ridge -bd 2
    pack .sd.t.d  .sd.t.r  .sd.t.c -side top -fill x

  
    frame .sd.t.d.1
    frame .sd.t.d.2
    frame .sd.t.d.3
    pack .sd.t.d.1 .sd.t.d.2 .sd.t.d.3 -side top -fill x

    label .sd.t.d.1.l -text "Termin verschieben auf ..." -font $bfnt12
    pack .sd.t.d.1.l -side left

    set sdo_startDy .sd.t.d.2.dy
    set sdo_startDm .sd.t.d.2.dm
    set sdo_startDd .sd.t.d.2.dd
    set sdo_startTh .sd.t.d.2.th
    set sdo_startTm .sd.t.d.2.tm

    tixControl $sdo_startDd  -label "Beginn"   -min 0 -max 31 -integer 1 \
	-options {  entry.width 2 label.width 14 } -selectmode immediate -autorepeat true -variable shiftStartDay
    tixControl $sdo_startDm -options { entry.width 2} -label "."  -min 0 -max 12 -integer 1 -validatecmd adoptMaxShiftStartDay  -selectmode immediate -autorepeat true -variable shiftStartMon
    tixControl $sdo_startDy -options { entry.width 4} -label "."  -min 1999 -max 2100 -integer 1  -selectmode immediate -autorepeat true -variable shiftStartYear
    tixControl $sdo_startTh -options { entry.width 2} -label "    -    "  -min 0 -max 23 -integer 1  -selectmode immediate -autorepeat true -variable shiftStartHour
    tixControl $sdo_startTm -options { entry.width 2} -label ":"  -min 0 -max 59 -integer 1  -selectmode immediate -autorepeat true -variable shiftStartMin
    label .sd.t.d.2.l -text " " -width 1 -font $bfnt
    pack  $sdo_startDd $sdo_startDm $sdo_startDy $sdo_startTh $sdo_startTm .sd.t.d.2.l -side left

    set sdo_stopDy .sd.t.d.3.dy
    set sdo_stopDm .sd.t.d.3.dm
    set sdo_stopDd .sd.t.d.3.dd
    set sdo_stopTh .sd.t.d.3.th
    set sdo_stopTm .sd.t.d.3.tm
    tixControl $sdo_stopDd -label "Ende"  -min 0 -max 31 -integer 1  -options {  entry.width 2 label.width 14 } -selectmode immediate -autorepeat true -variable shiftStopDay
    tixControl $sdo_stopDm -options { entry.width 2} -label "."  -min 0 -max 12 -integer 1 -validatecmd adoptMaxShiftStopDay  -selectmode immediate -autorepeat true -variable shiftStopMon
    tixControl $sdo_stopDy -options { entry.width 4} -label "."  -min 1999 -max 2100 -integer 1  -selectmode immediate -autorepeat true -variable shiftStopYear
    tixControl $sdo_stopTh -options { entry.width 2} -label "    -    "  -min 0 -max 23 -integer 1  -selectmode immediate -autorepeat true -variable shiftStopHour
    tixControl $sdo_stopTm -options { entry.width 2} -label ":" -min 0 -max 59 -integer 1 -selectmode immediate -autorepeat true -variable shiftStopMin
    label .sd.t.d.3.l -text " " -width 1 -font $bfnt
    pack  $sdo_stopDd $sdo_stopDm $sdo_stopDy $sdo_stopTh $sdo_stopTm .sd.t.d.3.l -side left

    set datelem "$sdo_stopDd $sdo_stopDm $sdo_stopDy $sdo_stopTh $sdo_stopTm $sdo_startDd $sdo_startDm $sdo_startDy $sdo_startTh $sdo_startTm"
    foreach w $datelem {
	$w subwidget entry configure  -font $pfnt
	$w subwidget label configure  -font $bfnt
    }
	     
	     
    frame .sd.t.r.1
    frame .sd.t.r.2
    pack .sd.t.r.1 .sd.t.r.2 -side top -fill x

    label .sd.t.r.1.l -text "Termin verlegen nach ..." -font $bfnt12
    pack .sd.t.r.1.l -side left
    
    set sdo_room .sd.t.r.2.m
    tixOptionMenu $sdo_room  -options {menubutton.width 14 label.width 18 } -label "Ort" 
    $sdo_room subwidget label configure -font $bfnt
    $sdo_room subwidget menubutton configure  -font $bfnt12
    pack   $sdo_room -side left 
    foreach room $roomList { $sdo_room add command $room -label $room }
    

    frame .sd.t.c.1
    frame .sd.t.c.2
    pack .sd.t.c.1 .sd.t.c.2 -side top -fill x
    
    label .sd.t.c.1.l -text "Details zur Verlegung:" -font $bfnt12
    pack .sd.t.c.1.l -side left -fill x
    text  .sd.t.c.2.t  -width 50 -height 4
    pack .sd.t.c.2.t -side left -fill x

    button .sd.b.abb -text "Abbruch" -command {closeWin .sd}
    pack .sd.b.abb -side left

    button .sd.b.ok -text "Verlegen" -command sendShiftDate
    pack .sd.b.ok -side right

    wm title .sd "Termin '$shiftTitel' verlegen"
    grab .sd
 #    puts [wm geometry .sd ]
    centerWin .sd 415 244
    update
   
}
proc adoptMaxShiftStartDay { mon } {
    global sdo_startDd monlen

    $sdo_startDd configure -max [ lindex monlen  $mon ]
    return $mon
}
proc adoptMaxShiftStopDay { mon } {
    global sdo_stopDd monlen

    $sdo_stopDd configure -max [ lindex monlen  $mon ]
    return $mon
}
proc sendShiftDate { } {
    global shiftStartDay shiftStartMon shiftStartYear shiftStartHour shiftStartMin
    global shiftStopDay shiftStopMon shiftStopYear shiftStopHour shiftStopMin
    global shiftRoom shiftAddDet shiftRefDate shiftRefTime shiftDid
    
    

    set ret [transfer shiftDate $shiftDid $shiftRefDate $shiftRefTime \
		 [format "%04d%02d%02d" $shiftStartYear $shiftStartMon $shiftStartDay]\
		 [format "%2d%02d" $shiftStartHour $shiftStartMin ] \
		 [format "%04d%02d%02d" $shiftStopYear $shiftStopMon $shiftStopDay]\
		 [format "%2d%02d" $shiftStopHour $shiftStopMin ] \
		 $shiftRoom $shiftAddDet]
    
    if { [string first $ret "ServerDown"] >=0 } {ServerDownDialog}
    if { [string range $ret 0 2] =="ERR"} {
	ErrorDialog [string range $ret 3 end]
    } else {
	drawUsersCalendar
    }
    closeWin .sd    
}

